#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=..\..\Icon\lse-gp.ico
#AutoIt3Wrapper_Res_Fileversion=1.0.0.13
#AutoIt3Wrapper_Res_Fileversion_AutoIncrement=p
#AutoIt3Wrapper_Res_SaveSource=y
#AutoIt3Wrapper_Res_Language=1033
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

#include <Date.au3>

$ProcList = ProcessList(@ScriptName)
If $ProcList[0][0] > 1 Then
	Exit
EndIf

;If (@ScriptName <> "KI-StartAdm.exe") Then
;	If (IniRead(@ScriptDir & "\KI-Start.ini", "Settings", "RunAsAdmin", "N") = "Y") Then
;		FileInstall(".\KI-StartAdm.exe", @ScriptDir & "\", 1)
;		Run(@ScriptDir & "\KI-StartAdm.exe", @ScriptDir)
;		Exit
;	EndIf
;EndIf

IniDelete(@ScriptDir & "\KI-Start.ini", "Debug-" & @ComputerName)

$tCur = _Date_Time_GetLocalTime()
IniWrite(@ScriptDir & "\KI-Start.ini", "Debug-" & @ComputerName, "LastStart", _Date_Time_SystemTimeToDateTimeStr($tCur))
ConsoleWrite(@ScriptName & @LF)

Global $StartDir = IniRead(@ScriptDir & "\KI-Start.ini", "Settings", "CopyTo", "")
Global $KxeSearch = FileFindFirstFile(@ScriptDir & "\*.kxe")
Global $KxeFile = FileFindNextFile($KxeSearch)
FileClose($KxeSearch)

DirCreate($StartDir)

Global $CheckProcWatch = StringLeft(IniRead(@ScriptDir & "\KI-Start.ini", "Settings", "CheckProcWatch", "Y"), 1)
If ($CheckProcWatch = "Y") Then
	If (ProcessExists("lse-procwatch.exe")) Then
		$ProgressOn = False
		$TimeElapsed = 0
		$Timer = TimerInit()

		$TimeToWait = 10000
		$TimeBeforeProgress = 2000

		While ProcessExists("lse-procwatch.exe") And $TimeElapsed < $TimeToWait
			If $TimeElapsed > $TimeBeforeProgress And Not WinExists("LSE KI-Start") Then
				ProgressOn("LSE KI-Start", "Waiting for previous processes to close", "lse-procwatch")
			EndIf

			If WinExists("LSE KI-Start") Then
				ProgressSet((($TimeElapsed - $TimeBeforeProgress) / ($TimeToWait - $TimeBeforeProgress)) * 100)
			EndIf
			$TimeElapsed = TimerDiff($Timer)
		WEnd
		ProgressOff()
		If ProcessExists("lse-procwatch.exe") Then
			MsgBox(0, "LSE KI-Start", "Previous processes are still running. Please wait for them to close. If you continue to see this, please contact IT or reboot workstation.")
			Exit
		EndIf
	EndIf
EndIf

ConsoleWrite($StartDir & @LF)

If StringLen($StartDir) = 0 Then
	$StartDir = @ScriptDir
	IniWrite(@ScriptDir & "\KI-Start.ini", "Settings", "CopyTo", $StartDir)
Else
	If $StartDir <> (@ScriptDir) Then
		CopyFiles(@ScriptDir & "\*.exe")
		CopyFiles(@ScriptDir & "\*.dll")
		CopyFiles(@ScriptDir & "\*.tlb")
		CopyFiles(@ScriptDir & "\*.kni")

		If StringLen($KxeFile) > 0 Then
			FileDelete($StartDir & "\" & $KxeFile)
			FileCopy(@ScriptDir & "\" & $KxeFile, $StartDir & "\" & $KxeFile)
		EndIf
	EndIf
EndIf

Local $aRuns = IniReadSection(@ScriptDir & "\KI-Start.ini", "RunFirst")
If @error Then
	IniWrite(@ScriptDir & "\KI-Start.ini", "Debug-" & @ComputerName, "Error", @error)
Else
	IniWrite(@ScriptDir & "\KI-Start.ini", "Debug-" & @ComputerName, "RunFirstCount", $aRuns[0][0])

	For $i = 1 To $aRuns[0][0]
		If FileExists($aRuns[$i][1]) Then
			ShellExecute($aRuns[$i][1])
		Else
			If FileExists(@ScriptDir & "\" & $aRuns[$i][1]) Then
				ShellExecute(@ScriptDir & "\" & $aRuns[$i][1])
			EndIf
		EndIf
	Next
EndIf

ShellExecute($StartDir & "\" & $KxeFile, "", $StartDir)

Func CopyFiles($sMask)
	Local $fSearch = FileFindFirstFile($sMask)
	Local $sFile = ""

	While True
		$sFile = FileFindNextFile($fSearch)
		If @error Then ExitLoop

		ConsoleWrite($sFile & @LF)
		If Not FileExists($StartDir & "\" & $sFile) and $sFile <> @ScriptName Then
			;FileCopy($sFile, $StartDir & $sFile)
		EndIf
	WEnd
EndFunc
